<?php
/**
 * $Id$
 *
 * Prevent SQL injections
 *
 * @author rICh <rich@atomyx.com>
 **/

class SqlVar {
  // translate possible problem variables into innoccuous counterparts
  public static function clean($strData,$blnStripNewlines = false) {
    if (is_integer($strData))
      return $strData;
    else {
      if (isset($strData)) {
	$strData = SqlVar::fixWord($strData);
	//Replaces all high-level Non-ascii (including greek & arabic)                                      
	// with appropriate htmlentity                                                                      
	// this is wacking out Doulbe Byte (like '私日本人')
	// commenting out for now
	// $strData = preg_replace('/([\xc0-\xdf].)/se', "'&#' . ((ord(substr('$1', 0, 1)) - 192) * 64 + (ord(substr('$1', 1, 1)) - 128)) . ';'", $strData);
	// $strData = preg_replace('/([\xe0-\xef]..)/se', "'&#' . ((ord(substr('$1', 0, 1)) - 224) * 4096 + (ord(substr('$1', 1, 1)) - 128) * 64 + (ord(substr('$1', 2, 1)) - 128)) . ';'", $strData);
	if($blnStripNewlines) {
	  // replaces all newlines in the variable
	  $strData = str_replace(array("\r", "\r\n", "\n"), ' ', $strData);
	}
	return  addslashes($strData);
      } else
	return "NULL";
    }
  }

  /* escape problem characters */
  public static function fixWord($scratch) {
    $start=chr(226).chr(128);
    $word=array();$fixword=array();
    $word[]=$start.chr(152);$fixword[]="'";
    $word[]=$start.chr(153);$fixword[]="'";
    $word[]=$start.chr(156);$fixword[]="\"";
    $word[]=$start.chr(157);$fixword[]="\"";
    return str_replace($word, $fixword, $scratch);
  }
}