<?php
/*
  $Id$
  
  Sessions Lab (in cookies-sessions Lab)

  This class provides session-based authentication. Assumes that 'session.auto_start' in php.ini is set to true
  The constructor, checks the 'logged_in' session key. if it's missing or set to false, then we will 'bounce'
  the user to 
  @author rICh <rich@quicloud.com>
*/

class Auth {
  // initializers
  private static $logged_in = false;
  private static $bounceToPage = '/'; // we should always have a default page
  private static $host = '';

  function __construct($bounceToPage) {
    self::$host = 'http://' . $_SERVER['HTTP_HOST'];
    if(isset($_SESSION['logged_in'])) {
      self::$logged_in = $_SESSION['logged_in'];
    }

    // make sure we're not constructing from 'login' page. This would result in an 'infinite refresh'
    if(strpos($bounceToPage,'/login.php') === false) {
      //      print "<hr>inConstructor!<hr>".var_dump(self::$logged_in)."<hr>";
      if (!self::$logged_in) {
	self::$bounceToPage = $bounceToPage;
	// store 'bounce to' in a session so that post-login, we can take the user back to the page they were
	// trying to access
	$_SESSION['bounce_to_page'] = self::$bounceToPage;
	$this->bounceToPage('/labs/cookies-sessions/solution/login.php');
      }
    }
  }

  public function logOut() {
    $_SESSION['bounce_to_page'] = '';
    $_SESSION['logged_in'] = self::$logged_in = false;
    $this->bounceToPage('/labs/cookies-sessions/solution/login.php?logged_out=true');
  }

  public function logIn() {
    $_SESSION['logged_in'] = self::$logged_in = true;
    if(isset(self::$bounceToPage)) {
      $this->bounceToPage();
    }
  }

  function buildLogoutLink() {
    return "<a href='/labs/cookies-sessions/solution/login.php?log_out=true'>Log Out</a>";
  }
  
  function bounceToPage($bounceToPage = '') {
    // if bounceToPage is empty, assume we're bouncing to the previously entered page
    if(empty($bounceToPage)) {
      // should never happen, but let's be safe
      if(!isset($_SESSION['bounce_to_page'])) {
	self::$bounceToPage = '/xyz';
      } else {
	self::$bounceToPage = $_SESSION['bounce_to_page'];
      }
      //      exit('loading bounceTo:'.self::$bounceToPage);
      $bounceToPage = self::$bounceToPage;
    }

    // host should always be populated, but let's be safe
    if(!isset(self::$host)) {
      self::$host = 'http://' . $_SERVER['HTTP_HOST'];
    }

    //    exit('dying with:'.self::$host.'<br>'.$bounceToPage.'<br>');
    // finally do our bounce
    header('Location: ' . self::$host . $bounceToPage);
  }
}
?>