<?php
/*
  $Id$
  
  Sessions Lab (in cookies-sessions Lab)

  This is the HTML 'login'  page to support login.
  * presents user with "email" and "password" fields & submits to self.
  * on submission back to self, if the username & password are valid, then we check 'bounce_to_page' session & if it's set, we bounce the user back to that page.

  @author rICh <rich@quicloud.com>
*/

require_once('Auth.php');
$objAuth = new Auth('/login.php'); // passing in login.php sends a special signal to Auth to not bounce
if(isset($_GET['log_out'])) {
  $objAuth->logOut();
} else if(isset($_GET['logged_out'])) {
  print "you have been logged out. You can browse back to the web form by <a href='/labs/cookies-sessions/solution/sessions-web-form.php'>clicking here</a>";
  exit(); // prevents further processing
} else if(isset($_SESSION['logged_in']) && $_SESSION['logged_in']) {
  exit("You're already logged in. Normally, we'd redirect you somewhere useful...");
}
//print "<hr>".print_r($_SESSION).'<hr>';

$arrFormVars = array('strEmail','strPassword');
foreach($arrFormVars as $strVar) {
  // initialize all of our variables we'll use in-page
  $$strVar = '';
  $strVarError = $strVar . 'Error';
  $$strVarError = 'black';
  //  print "$strVarError:".$$strVarError."<br />";
}

// !empty means the form has been submitted
if(isset($_POST) && !empty($_POST)) {
  foreach($arrFormVars as $strVar) {
    if(isset($_POST[$strVar]) && (!empty($_POST[$strVar]))) {
      $$strVar = $_POST[$strVar];
    } else {
      // the following code sets up variables like
      ${$strVar . 'Error'} = 'red';
      //      print "$strVar . Error = " . ${$strVar . 'Error'}."\n";
    }
  }

}

function validateForm($arrFormParams) {
  $blnReturn = true;
  // we need to check if the form has been submitted at all
  if(!isset($_POST['submit'])) {
    $blnReturn = false;
  } else {
    foreach($arrFormParams as $strVar) {
      // first set up our 'valid/invalid' $blnReturn. If *any* of the params are missing, we're 'invalid'
      global ${$strVar . 'Error'}; // this is horrible, horrible practice.

      //independently validate email & password
      if($strVar == 'strEmail') {
	if(!filter_var($_POST[$strVar], FILTER_VALIDATE_EMAIL)) {
	  // just mark it as red as we did before.. ideally we'd want a message about 'invalid email';
	  ${$strVar . 'Error'} = 'red';
	}
      } elseif($strVar == 'strPassword') {
	if(strlen(trim($_POST[$strVar])) < 6) {
	  ${$strVar . 'Error'} = 'red';
	}
      }

      if(${$strVar . 'Error'} == 'red') {
	$blnReturn = false;
      }
    }
  }
  // we've cycled through the foreach without hitting any 'returns', all must be valid
  return $blnReturn;
}
/*
print '<hr>';
var_dump($_REQUEST);
print '<hr>';
*/
if (!validateForm($arrFormVars)) { // if page is not submitted to itself echo the form
?>
<html>
<head>
<title>Personal INFO</title>
</head>
<body>
<form method="post" action="<?php echo $_SERVER['PHP_SELF'] ;?>">
    <span style='color:<?php echo $strEmailError ?>'>Email</span>:<input type="text" size="12" maxlength="100" name="strEmail" value='<?php echo $strEmail ?>'><br />
    <span style='color:<?php echo $strPasswordError ?>'>Password</span>:<input type="password" size="12" maxlength="8" name="strPassword" value='<?php echo $strPassword ?>'><br />
<input type="submit" value="submit" name="submit">
</form>
<?php
} else {
  // they passed auth, log them in (which automatically bounces them to prev page they were trying to access
  $objAuth->logIn();
}
?>