<?php
/*
  $Id$
  
  Data Types Lab

  This demonstrates a simple class.
  The class has 1 class variable:
    * $page -- contains the contents of the page to be output. 
  The class has 3 methods:
    * Page (the constructor) -- just initializes the class var ($page)
    * addHeader -- adds a page header to the class var
    * addContent -- adds the content to the class var
    * addFooter -- adds a page footer to the class var
    * get -- returns the class var

  @author rICh <rich@quicloud.com>
  */

// Page class
class Page {
  // Declare a class member variable
  public $page;

  // The constructor function
  function Page() {
    $this->page = '';
  }

  // Generates the top of the page
  function addHeader($title) {
    $this->page .= <<<EOD
      <html>
      <head>
      <title>$title</title>
      </head>
      <body>
      <h1 align="center">$title</h1>
EOD;
  }

  // Adds some more text to the page
  function addContent($content) {
    $this->page .= $content;
  }

  // Generates the bottom of the page
  function addFooter($year, $copyright) {
    $this->page .= <<<EOD
      <div align="center">&copy; $year $copyright</div>
				   </body>
				   </html>
EOD;
  }
  // Gets the contents of the page
  function get() {
    return $this->page;
  }
}
?>