<?php
/*
  $Id$

  Date Time Lab
  
  This code is a 'stopwatch' class which allows us to benchmark speed of our code
  Includes three methods:
  * Constructor (sets up
  
  @author rICh <rich@quicloud.com>                                                                                          
*/
class Stopwatch {
  private $intRound = 5;
  private $intStartTime = 0;

  function __construct ($intRound = 5) {
    if(!empty($intRound)) {
      $this->round = (int) $intRound;
    }
    $this->intStartTime = microtime();
  }

  function elapsedSinceStart( ) {
    $intStartTime     = $this->getTime($this->intStartTime);
    $elapsedSinceStart     = $this->getTime();
    // this returns # of seconds, rounded to $intRound
    return round($elapsedSinceStart - $intStartTime, $this->round);
  }

  function getTime($strTime = FALSE) {
    if ( !$strTime) $strTime = microtime();
    $arrReturn = explode(' ', $strTime);
    // microtime returns "msec sec", where msec is the # of milliseconds since sec,
    // and sec is the # of seconds since unix epoch (1970, Jan 1 00:00:00). Essentially, these two
    // values together comprise the # of seconds (down to the microsecond) that elapsed since $strTime.
    return $arrReturn[0] + $arrReturn[1];
  }

}
?>