<?php
/*
  $Id$

  Date Time Lab
  
  This code uses the 'Stopwatch' class to determine which is faster -- double or single quotes.
  Simply initializes the Stopwatch class & then calls it at different times.
  Because these functions run so fast, we have to do them many times over (we're running a million times)
  
  @author rICh <rich@quicloud.com>                                                                                          
*/

require_once('Stopwatch.php');

// always initialize at code top
$intIterations = 1000000; // change this to do more/less iterations
$strHolder = '';

// get benchmark for dbl quotes
$objDoubleQuotesStopwatch = new Stopwatch();
for($i=0; $i < $intIterations; $i++) {
  $strHolder = "$i";
}
echo "Double quotes ran in " . $objDoubleQuotesStopwatch->elapsedSinceStart() . " seconds \n";

// get benchmark for single quotes
// we need a brand new stopwatch
$objSingleQuotesStopwatch = new Stopwatch();
for($i=0; $i < $intIterations; $i++) {
  $strHolder = '$i'; // this should run faster since it does not interpolate
}
echo "Single quotes ran in " . $objSingleQuotesStopwatch->elapsedSinceStart() . " seconds \n";

?>

