#!/usr/bin/php
<?
/*
  $Id$
  
  File Reading Extra Credit Lab

  Takes two CSV (comma separated value) files over command line
  * Compares the files not only line by line, but also cell-by-cell (value-by-value)
  * If any cells differ, output the cells that differ and exit script immediately
  * If all cells match, output "all match" back to user.

  @author rICh <rich@quicloud.com>
*/

// this function will compare the line by line contents of two files (assumed to be csv files)
// it will return lines of files that do not match.
$strFile1 = $argv[1];
$strFile2 = $argv[2];

function parseData($strFilename) {
  $strAllData = file($strFilename);
  foreach($strAllData as $intLineNum => $strLineData) {
    $arrLineData = explode(',',$strLineData);
  }
  return $arrLineData;
}

$arrFile1 = parseData($strFile1);
$arrFile2 = parseData($strFile2);

$intRow = 0;
foreach($arrFile1 as $intKey => $strVal) {
  if(!isset($arrFile2[$intKey]) || ($arrFile2[$intKey] != $strVal)) {
    exit("Column $intKey, row $intRow of $strFile1 doesn't match\n");
  }
  $intRow++;
}
print "All rows match fine.\n";

?>