<?php
/*
  $Id$
  
  Regex Lab

  This demonstrates calling a simple class.
  Our (much cleaner) code just simply instantiates the Page object & calls several methods inside of it.

  Code is explained further at: http://docstore.mik.ua/orelly/webprog/pcook/ch11_14.htm

  @author rICh <rich@quicloud.com>
  */
/* here's an example of what your log file entries should look like:
67.6.152.212 - - [08/Jan/2014:21:47:17 +0000] "GET / HTTP/1.1" 403 3839 "-" "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_8_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36"

Full details on log file contents explained here:
http://httpd.apache.org/docs/2.2/logs.html (search in page for “common log”)
*/

// if you're accessing the log file directly, YOU MUST RUN THIS PROGRAM AS ROOT (permissions on access_log)
$log_file = '/var/log/httpd/access_log';

// the magical regex -- can you explain what each part does?
$pattern = '/^([^ ]+) ([^ ]+) ([^ ]+) (\[[^\]]+\]) "(.*) (.*) (.*)" ([0-9\-]+) ([0-9\-]+) "(.*)" "(.*)"$/';

$fh = fopen($log_file,'r') or die($php_errormsg);
$i = 1;
$requests = array();
while (! feof($fh)) {
  // read each line and trim off leading/trailing whitespace
  if ($s = trim(fgets($fh,16384))) {
    // match the line to the pattern
    if (preg_match($pattern,$s,$matches)) {
      /* put each part of the match in an appropriately-named
       * variable */
      list($whole_match,$remote_host,$logname,$user,$time,
	   $method,$request,$protocol,$status,$bytes,$referer,
	   $user_agent) = $matches;
      // keep track of the count of each request 
      $requests[$request]++;
    } else {
      // complain if the line didn't match the pattern 
      error_log("Can't parse line $i: $s");
    }
  }
  $i++;
}
fclose($fh) or die($php_errormsg);

// sort the array (in reverse) by number of requests 
arsort($requests);

// print formatted results
foreach ($requests as $request => $accesses) {
  printf("%6d   %s\n",$accesses,$request);
}

?>