<?php
/*
  $Id$
  
  Web Forms Lab

  This is  a self-contained one pager which displays a webform to the user, validates output, provides user
  with visual indication of what's been left out (all fields are required), and finally sends back a "thank you"
  page.

  We leverage many form field types, some of which are multi-select (and return arrays).

  We also make use of both variable variables ($$) and references (&$) to make our lives a little easier.

  NOTE: This is NOT an example of "good coding" practices, but it is something you will see frequently in PHP
  code. Ideally, we would want to wrap up all of this 'validation' business into a class, and not clutter our
  HTML up with it. The variable variable, and reference examples are quite representative of what you will see
  in the real world.

  Repurposed from code at http://www.tizag.com/phpT/examples/formfinale.php

  @author rICh <rich@quicloud.com>
  */

$arrFormVars = array('strFirst','strLast','strGender','strFood','strQuote','strEducation','strTimeOfDay');
foreach($arrFormVars as $strVar) {
  // initialize all of our variables we'll use in-page
  $$strVar = '';
  $strVarError = $strVar . 'Error';
  $$strVarError = 'black';
  //  print "$strVarError:".$$strVarError."<br />";
}

// !empty means the form has been submitted
if(isset($_POST) && !empty($_POST)) {
  foreach($arrFormVars as $strVar) {
    if(isset($_POST[$strVar]) && (!empty($_POST[$strVar]))) {
      $$strVar = $_POST[$strVar];
    } else {
      // the following code sets up variables like
      ${$strVar . 'Error'} = 'red';
      //      print "$strVar . Error = " . ${$strVar . 'Error'}."\n";
    }
  }

  /*
the 'variable variable' gives us a whole lot of flexibility... if we couldn't do the above, we'd have had to do
the following for each and every variable:
if(isset($_POST['strFirst']) && (!empty($_POST['strFirst']))) {
  $strFirst = $_POST["strFirst"];
}
  */
}
$arrSelected = array();

function validateForm($arrFormParams,$arrSelected) {
  $blnReturn = true;
  // we need to check if the form has been submitted at all
  if(!isset($_POST['submit'])) {
    $blnReturn = false;
  } else {
    foreach($arrFormParams as $strVar) {
      // first set up our 'valid/invalid' $blnReturn. If *any* of the params are missing, we're 'invalid'
      global ${$strVar . 'Error'}; // this is horrible, horrible practice.
      // but if we don't do it here, the the following line will not work (eg: there is no local 'strFirstError')
      if(${$strVar . 'Error'} == 'red') {
	$blnReturn = false;
      }
      
      // next, handle 'special' params like radio buttons, checkboxes & select lists
      if($strVar == 'strGender') {
	if($_POST[$strVar] == 'Male') {
	  $arrSelected['strMaleChecked'] = 'checked="checked"';
	} else if($_POST[$strVar] == 'Female') {
	  $arrSelected['strFemaleChecked'] = 'checked="checked"';
	}
      } elseif($strVar == 'strFood') {
	// strFood is an ARRAY, process it as such
	// this is a multi-select box, so make sure we don't do any if... else...
	if(in_array('Steak',$_POST[$strVar])) {
	  $arrSelected['strSteakSelected'] = 'checked';
	}
	if(in_array('Pizza',$_POST[$strVar])) {
	  $arrSelected['strPizzaSelected'] = 'checked';
	}
	if(in_array('Chicken',$_POST[$strVar])) {
	  $arrSelected['strChickenSelected'] = 'checked';
	}
      } elseif($strVar == 'strEducation') {
	if($_POST[$strVar] == 'Jr.High') {
	  $arrSelected['strJuniorHighSelected'] = 'selected';
	} elseif($_POST[$strVar] == 'HighSchool') {
	  $arrSelected['strHighSchoolSelected'] = 'selected';
	} elseif($_POST[$strVar] == 'College') {
	  $arrSelected['strCollegeSelected'] = 'selected';
	}
      } elseif($strVar == 'strTimeOfDay') {
	// strTimeOfDay is an ARRAY, process it as such
	// this is a multi-select box, so make sure we don't do any if... else...
	if(in_array('Morning',$_POST[$strVar])) {
	  $arrSelected['strMorningSelected'] = 'selected';
	}
	if(in_array('Day',$_POST[$strVar])) {
	  $arrSelected['strDaySelected'] = 'selected';
	}
	if(in_array('Night',$_POST[$strVar])) {
	  $arrSelected['strNightSelected'] = 'selected';
	}
      }
    }
  }
  // we've cycled through the foreach without hitting any 'returns', all must be valid
  return $blnReturn;
}
/*
print '<hr>';
var_dump($_REQUEST);
print '<hr>';
*/
if (!validateForm($arrFormVars,&$arrSelected)) { // if page is not submitted to itself echo the form
?>
<html>
<head>
<title>Personal INFO</title>
</head>
<body>
<form method="post" action="<?php echo $_SERVER['PHP_SELF'] ;?>">
    <span style='color:<?php echo $strFirstError ?>'>First Name</span>:<input type="text" size="12" maxlength="12" name="strFirst" value='<?php echo $strFirst ?>'><br />
    <span style='color:<?php echo $strLastError ?>'>Last Name</span>:<input type="text" size="12" maxlength="36" name="strLast" value='<?php echo $strLast ?>'><br />
    <span style='color:<?php echo $strGenderError ?>'>StrGender</span>:
    Male:<input type="radio" value="Male" name="strGender" <?php echo $arrSelected['strMaleChecked'] ?>>
    Female:<input type="radio" value="Female" name="strGender" <?php echo $arrSelected['strFemaleChecked'] ?>><br />
    <span style='color:<?php echo $strFoodError ?>'>Please choose your favorite food</span>:<br />
    Steak:<input type="checkbox" value="Steak" name="strFood[]" <?php echo $arrSelected['strSteakSelected'] ?>><br />
    Pizza:<input type="checkbox" value="Pizza" name="strFood[]" <?php echo $arrSelected['strPizzaSelected'] ?>><br />
    Chicken:<input type="checkbox" value="Chicken" name="strFood[]" <?php echo $arrSelected['strChickenSelected'] ?>><br /><br />
   <span style='color:<?php echo $strQuoteError ?>'>Enter your favorite quote!</span>:<br />
<textarea rows="5" cols="20" name="strQuote" wrap="physical"><?php echo $strQuote ?></textarea><br />
    <span style='color:<?php echo $strEducationError ?>'>Select your highest level of Education</span>:<br />
<select name="strEducation">
<option value="Jr.High" <?php echo $arrSelected['strJuniorHighSelected'] ?>>Jr.High</option>
<option value="HighSchool" <?php echo $arrSelected['strHighSchoolSelected'] ?>>HighSchool</option>
<option value="College" <?php echo $arrSelected['strCollegeSelected'] ?>>College</option></select><br />
    <span style='color:<?php echo $strTimeOfDayError ?>'>Select your favorite time of day</span>:<br />
<select name="strTimeOfDay[]" size="3" multiple>
<option value="Morning" <?php echo $arrSelected['strMorningSelected'] ?>>Morning</option>
<option value="Day" <?php echo $arrSelected['strDaySelected'] ?>>Day</option>
<option value="Night" <?php echo $arrSelected['strNightSelected'] ?>>Night</option></select><br />
<input type="submit" value="submit" name="submit">
</form>
<?php
} else {
  echo "<br />Hello ".$strFirst." ".$strLast."!<br />";
  echo "You are ".$strGender.", and you like ";
  if(is_array($strFood)) {
    foreach ($strFood as $strOneFood) {
      echo $strOneFood."<br />";
    }
  }
  echo "Your favorite quote is:<i>".$strQuote."</i><br />";
  echo "You're favorite time(s) is/are ".implode(',',$strTimeOfDay).", and you passed ".$strEducation."!<br />";
}
?>